unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, gifimage, jpeg, CDIBs, Menus, RxMenus, shellapi,
  ExtDlgs, ComCtrls, filectrl;

type
  TMainForm = class(TForm)
    OriginalImage: TImage;
    OriginalLabel: TLabel;
    IconLabel: TLabel;
    sizelabel: TLabel;
    newsizelabel: TLabel;
    Bevel1: TBevel;
    MaskPanel: TPanel;
    MainMenu: TMainMenu;
    File1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Readme1: TMenuItem;
    Open1: TMenuItem;
    Exit1: TMenuItem;
    SpeedButton1: TSpeedButton;
    ConvertButton: TSpeedButton;
    SpeedButton2: TSpeedButton;
    OpenDialog: TOpenPictureDialog;
    ConvertPanel: TPanel;
    StatusLabel: TLabel;
    ProgressBar: TProgressBar;
    filelabel: TLabel;
    IconImage: TImage;
    maskradio: TRadioButton;
    BottomRightRadio: TRadioButton;
    NoneRadio: TRadioButton;
    Label1: TLabel;
    Label2: TLabel;
    fourBitCheck: TCheckBox;
    ColorDialog: TColorDialog;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ToIcon;
    procedure BgButtonClick(Sender: TObject);
    procedure MaskClick(Sender: TObject);
    procedure OriginalImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SaveToFile(const filename:string);
    procedure FormDestroy(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Readme1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Load(F : string);
    procedure BatchConvert;
    procedure About1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure maskcheckClick(Sender: TObject);
    procedure maskradioClick(Sender: TObject);
    procedure BottomRightRadioClick(Sender: TObject);
    procedure NoneRadioClick(Sender: TObject);
    procedure MaskPanelClick(Sender: TObject);
  private
    { Private declarations }
    procedure WMDropFile(var Message:Tmessage);message Wm_DROPFILES;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;
  NewIcon : TIcon;
  FileName : string;
  Image: TImageList;
  newwidth, newheight : integer;
  new : TBitmap;
  ANDMask: TBitmap;
  XORMask: TBitmap;
  First : boolean;

implementation

uses batchunit, aboutunit;


{$R *.DFM}

procedure TMainForm.BitBtn1Click(Sender: TObject);
begin
     if batchform.fourBitCheck.checked then
     begin //if we only want a 16 color icon use the default saveto file
         iconImage.Picture.SaveToFile(filename);
     end else begin //256 colors
         SaveToFile(filename);
     end;
     MessageDlg('Converted!', mtInformation, [mbOK], 0);
end;

procedure TMainForm.SaveToFile(const Filename : string);
var f : tfilestream;
    BBuffer : byte;
    WBuffer : word;
    DWBuffer : DWord;
    bmp : BITMAPINFOHEADER;
    x,y,z : integer;
    dib : TDIB;
    Color : RGBQUAD;
begin
     //saves to file with 256 colors

     //new Save to File method
     f:=tfilestream.Create(filename,fmCreate);
     //write ICONDIR header
     wbuffer:=0; f.WriteBuffer(wbuffer,2); //reserved (0)
     wbuffer:=1; f.writeBuffer(wbuffer,2); // resource type (1 = icon)
     wbuffer:=1; f.writebuffer(wbuffer,2); // count (1 in this case)
     //write single ICONDIRENTRY record
     BBuffer:=new.Width; f.writebuffer(BBuffer,1); // width in pixels
     BBuffer:=new.height; f.writebuffer(BBuffer,1); // height in pixels
     BBuffer:=255; f.writebuffer(BBuffer,1); // color count ( 0 if >=8bpp)
     BBuffer:=0; f.writebuffer(BBuffer,1); // reserved (0)
     WBuffer:=1; f.writebuffer(WBuffer,2); // color planes (1)
     WBuffer:=8; f.writebuffer(WBuffer,2); // bits pet pixel (0)
     DWBuffer:=(256*4)+new.width*(new.height*2)+40; f.writebuffer(DWBuffer,4); // bytes in resource
     DWBuffer:=$16; f.writebuffer(DWBuffer,4); // image offset

     //write single ICONIMAGE
     bmp.bisize:=40; //size of bmp structure
     bmp.biWidth:=new.width; // width
     bmp.biheight:=new.width*2; // height (double image height for both XOR and AND masks)
     bmp.biPlanes:=1;  //number of planes must be 1
     bmp.biBitCount:=8; // bit count, 1,4,8,16,24,32
     bmp.biSizeImage:=new.width*(new.height)*2 + (new.width*2) + (new.height*2);
     bmp.biCompression:=0;
     bmp.biXPelsPerMeter:=0;
     bmp.biYPelsPerMeter:=0;
     bmp.biClrUsed:=0;
     bmp.biClrImportant:=0;
     f.writebuffer(bmp,40);
     //write color table
     dib:=tDib.Create;
     dib.Assign(Xormask);
     for x:=0 to 255 do
     begin
          Color.rgbRed:=dib.Colors[x] mod $100;
          Color.rgbGreen:=(dib.Colors[x] div $100) mod $100;
          Color.rgbBlue:=dib.Colors[x] div $10000;
          Color.rgbReserved:=0;
          f.writebuffer(Color,sizeof(Color));
     end;
     //Xor bits
     f.writebuffer(dib.bits^,dib.width*DIB.height);
     //And bits
     dib.Assign(Andmask);
     f.writebuffer(dib.bits^,dib.width*dib.height);
     //close and free stream
     dib.free;
     f.Free;
end;


procedure TMainForm.BitBtn2Click(Sender: TObject);
begin
     close;
end;

procedure TMainForm.FormShow(Sender: TObject);
var x : integer;
begin
     //accept drag'n'drop from explorer
     DragAcceptFiles(handle,true);

end;

procedure TMainform.Load(F : string);
var x : integer;
    gifimage : TGifImage;
    jpgimage : TJpegImage;
begin
     FileName:=f;
     //load original image
     if (uppercase(extractfileext(filename))='.BMP') then
     begin //bitmap
          try
             originalimage.Picture.LoadFromFile(filename);
             maskpanel.color:=originalimage.picture.bitmap.Canvas.Pixels[originalimage.picture.width-1,originalimage.picture.height-1];
          except
            messagedlg(filename+': Can''t open file!',mtError,[mbOK],0);
            close;
          end;
     end else if (uppercase(extractfileext(filename))='.GIF') then
     begin //gif
           try
             gifimage := TGifImage.Create;
             gifimage.LoadFromFile(filename);
             originalimage.picture.bitmap.Assign(gifimage.bitmap);
             maskpanel.color:=originalimage.picture.bitmap.Canvas.Pixels[originalimage.picture.width-1,originalimage.picture.height-1];
             gifimage.free;
           except
             messagedlg(filename+': Can''t open file!',mtError,[mbOK],0);
             close;
           end;
     end else if (uppercase(extractfileext(filename))='.JPG') then
     begin //gif
           try
             jpgimage := TJpegImage.Create;
             jpgimage.LoadFromFile(filename);
             jpgimage.DIBNeeded;
             originalimage.picture.bitmap.width:=jpgimage.Width;
             originalimage.picture.bitmap.height:=jpgimage.height;
             originalimage.picture.bitmap.Canvas.Draw(0,0,jpgimage);
             maskpanel.color:=originalimage.picture.bitmap.Canvas.Pixels[originalimage.picture.width-1,originalimage.picture.height-1];
             jpgimage.free;
           except
             messagedlg(filename+': Can''t open file!',mtError,[mbOK],0);
             close;
           end;
     end else begin
          messagedlg(filename+': Only BMPs, JPGs and GIFs are supported at the moment',mtError,[mbOK],0);
     end;
     newwidth:=originalimage.Picture.width;
     newheight:=originalimage.Picture.height;
     sizelabel.caption:=inttostr(originalimage.Picture.width) + ' x '+inttostr(originalimage.Picture.height);
     newsizelabel.caption:=inttostr(newwidth) + ' x '+inttostr(newheight);
     originallabel.Caption:=extractfilename(FileName);
     filename:=copy(filename,1,length(filename)-4);
     filename:=filename+'.ico';
     iconlabel.Caption:=extractfilename(filename);
     ToIcon;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
     AndMask := TBitmap.create;
     XOrMask := TBitmap.create;
     new :=TBitmap.create;
     First:=true;
end;

procedure TMainForm.ToIcon;
var
    maskcolor : Tcolor;
    IconSizeX,IconSizeY : integer;
    x, y : integer;
begin
  //converts bitmap to icon
  //icon for display
  //IconSizeX := GetSystemmetrics(SM_CXICON);
  //IconSizeY := GetSystemmetrics(SM_CYICON);
  IconSizeX := originalImage.picture.width;
  IconSizeY := originalImage.picture.height;
  originalimage.picture.bitmap.pixelformat:=pf8bit;
  new.pixelformat:=pf8bit;
  new.Width:=IconSizeX;
  new.height:=IconSizeY;
  new.canvas.StretchDraw(rect(0,0,IconSizeX, IconSizeY),originalimage.picture.bitmap);
  iconimage.picture:=originalimage.picture;
  iconimage.picture.Bitmap.width:=iconsizeX;
  iconimage.picture.Bitmap.height:=iconsizeY;

  //use appropriate mask colour
  if maskradio.Checked then maskcolor:=maskpanel.Color
     else if BottomRightRadio.Checked then maskcolor := originalimage.picture.bitmap.Canvas.Pixels[originalimage.picture.width-1,originalimage.picture.height-1]
     else maskcolor:=clNone;

  iconimage.picture.bitmap.TransparentColor:=maskcolor;
  iconimage.Repaint;
  newsizelabel.caption:=inttostr(IconSizeX) + ' x '+inttostr(IconSizeY);
  //icon masks for writing
  AndMask.monochrome:=true;
  andmask.width:=IconSizeX;
  andmask.height:=IconSizeX;
  for x:= 0 to IconSizeX -1 do
  begin
       for y:=0 to IconSizeY -1 do
       begin
            if new.canvas.Pixels[x,y]=maskcolor then andmask.canvas.pixels[x,y]:=clWhite
               else andmask.canvas.pixels[x,y]:=clBlack;
       end;
  end;
  XorMask.Assign(new);
  for x:= 0 to IconSizeX -1 do
  begin
       for y:=0 to IconSizeY -1 do
       begin
            if new.canvas.Pixels[x,y]=maskcolor then xormask.canvas.pixels[x,y]:=clBlack;
       end;
  end;
end;

procedure TMainForm.BgButtonClick(Sender: TObject);
begin
     if mainform.color=clBtnFace then mainform.color:=clWhite
     else if mainform.color=clWhite then mainform.color:=ClBlack
     else if mainform.color=clBlack then mainform.color:=clBtnFace;
end;

procedure TMainForm.MaskClick(Sender: TObject);
begin
     cursor:=crHandPoint;
end;

procedure TMainForm.OriginalImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     maskRadio.checked:=true;
     maskpanel.color:=TImage(sender).Canvas.Pixels[x,y];
     toIcon;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  //free bitmaps
  AndMask.free;
  XorMask.free;
  new.free;
end;

procedure TMainForm.Exit1Click(Sender: TObject);
begin
     Application.Terminate;
end;

procedure TMainForm.Readme1Click(Sender: TObject);
begin
     shellexecute(handle,'Open',PChar(extractfilepath(Application.exename)+'2Icon-Readme.txt'),'',PChar(extractfilepath(Application.exename)),SW_SHOWNORMAL);
end;

procedure TMainForm.Open1Click(Sender: TObject);
var x : integer;
    temp : string;
begin
     if opendialog.execute then
     begin
          if opendialog.files.count>1 then
          begin
               batchform.batchlist.clear;
               for x:=0 to opendialog.files.count - 1 do
               begin
                    batchform.batchlist.Items.Add(opendialog.files[x]);
               end;
               batchconvert;
          end else begin
              load(opendialog.FileName);
          end;
     end;
end;

procedure Tmainform.WmDropFile(var Message:Tmessage);
var fname : PChar;
    count : integer;
    x : integer;
begin
     count:=dragQueryFile(message.wparam,$FFFFFFFF,'',0);
     batchform.batchList.clear;
     for x:=0 to count-1 do
     begin
          fname:=StrAlloc(256);
          dragqueryfile(message.wparam,x,fname,256);
          batchform.batchlist.items.add(string(fname));
          FileName:=string(fname);
          StrDispose(fname);
     end;
     DragFinish(message.wparam);
     if count>1 then BatchConvert else Load(FileName);
end;

procedure Tmainform.BatchConvert;
var x : integer;
begin
     //does a batch convert
     if batchform.ShowModal=mrok then
     begin
          progressbar.Position:=0;
          progressbar.max:=batchform.batchlist.Items.Count;
          convertpanel.Visible:=true;
          for x:=0 to batchform.batchlist.items.count-1 do
          begin
               filelabel.Caption:=minimizeName(batchform.batchlist.Items[x],filelabel.Canvas,filelabel.Width);
               progressbar.Position:=progressbar.Position+1;
               Application.ProcessMessages;
               Load(batchform.batchlist.items[x]);
               //move mask & color depth settings
               maskradio.checked := batchform.maskradio.checked;
               Noneradio.checked := batchform.Noneradio.checked;
               BottomRightRadio.checked := batchform.BottomRightRadio.checked;
               MaskPanel.Color := Batchform.maskPanel.color;
               fourbitcheck.checked := fourbitcheck.checked;
               if fourBitCheck.checked then
               begin //if we only want a 16 color icon use the default saveto file
                   iconImage.Picture.SaveToFile(filename);
               end else begin //256 colors
                   SaveToFile(filename);
               end;
          end;
          convertpanel.Visible:=false;
          MessageDlg('Batch conversion complete!', mtInformation, [mbOK], 0);
     end;
end;

procedure TMainForm.About1Click(Sender: TObject);
begin
     aboutbox.ShowModal;
end;

procedure TMainForm.FormActivate(Sender: TObject);
var x : integer;
begin
  if First then
  begin
     First:=false;
     //get filename
     if paramcount=0 then
     begin
          exit;
     end;
     if paramcount=1 then
     begin
          filename:=paramstr(1);
          originallabel.Caption:=extractfilename(filename);
          load(FileName);
     end;
     if paramcount>1 then
     begin
          batchform.batchList.clear;
          for x:=1 to paramcount do
          begin
               batchform.batchlist.items.add(ParamStr(x));
          end;
          batchconvert;
     end;
   end;
end;

procedure TMainForm.maskcheckClick(Sender: TObject);
begin
     toicon;
end;

procedure TMainForm.maskradioClick(Sender: TObject);
begin
    toIcon;
end;

procedure TMainForm.BottomRightRadioClick(Sender: TObject);
begin
    toIcon;
end;

procedure TMainForm.NoneRadioClick(Sender: TObject);
begin
    toIcon;
end;

procedure TMainForm.MaskPanelClick(Sender: TObject);
begin
    if colorDialog.execute then
    begin
        maskPanel.color := colorDialog.color;
    end;
    MaskRadio.checked:=true;
    ToIcon;
end;

end.
